#include <stdio.h>

int main(int argc,char *argv[]) {
	FILE *fp1,*fp2;
	size_t sz;
	int nbg_header[8];
	char device_name[32];
	int file_type[32];
	int file_offset[32];
	int file_size[32];
	char cid[32];
	char version[16];
	char language[16];
	int fn,rc,sr,rr,rs,fm,i,j;
	char nh[9],dn[33],ci[33],vr[17],lg[17];
	long fs,fo;
	char fb[65536],nn[32768],wn[32768];

	if(argc<8) {
		printf("usage: nb2nbg <NBG file> <device name> <cid> <version> <language> <file type> <NB file> [<file type> <NB file>...]\n");
		return(1);
	}

	if(((argc-6) % 2)==1) {
		printf("last parameter is not NB file.\n");
		return(1);
	}
	fm=(argc-6)/2;
	if(fm>32) {
		printf("NB file is up to 32.\n");
	}

	strcpy(nh,"HTCIMAGE");
	for(i=0;i<8;i++) nbg_header[i]=nh[i];

	j=strlen(argv[2]);
	if(j>=32) j=32;
	for(i=0;i<j;i++) device_name[i]=argv[2][i];
	while(i<32) device_name[i++]=0;

	fo=512;
	for(i=0;i<32;i++) {
		if(i<fm) {
			sscanf(argv[6+(i*2)],"%X",&file_type[i]);
			fp1=fopen(argv[6+(i*2)+1],"rb");
			if(fp1==NULL) {
				printf("NB file open error. (%s)\n",argv[6+(i*2)+1]);
				return(1);
			}
			sr=fseek(fp1,0,SEEK_END);
			if(sr!=0) {
				printf("NB file seek error. (%s)\n",argv[6+(i*2)+1]);
				fclose(fp1);
				return(1);
			}
			fs=ftell(fp1);
			if(fs<0) {
				printf("NB file size get error. (%s)\n",argv[6+(i*2)+1]);
				fclose(fp1);
				return(1);
			}
			fclose(fp1);
			file_offset[i]=fo;
			file_size[i]=fs;
			fo=fo+fs;
			printf("file %d : type = 0x%X , size = %10d , name = %s\n",i,file_type[i],file_size[i],argv[6+(i*2)+1]);
		} else {
			file_type[i]=0;
			file_offset[i]=0;
			file_size[i]=0;
		}
	}

	j=strlen(argv[3]);
	if(j>=32) j=32;
	for(i=0;i<j;i++) cid[i]=argv[3][i];
	while(i<32) cid[i++]=0;

	j=strlen(argv[4]);
	if(j>=16) j=16;
	for(i=0;i<j;i++) version[i]=argv[4][i];
	while(i<16) version[i++]=0;

	j=strlen(argv[5]);
	if(j>=16) j=16;
	for(i=0;i<j;i++) language[i]=argv[5][i];
	while(i<16) language[i++]=0;

	fp2=fopen(argv[1],"wb");
	if(fp2==NULL) {
		printf("NBG file open error.\n");
		return(1);
	}

	sz=fwrite(nbg_header,sizeof(nbg_header),1,fp2);
	if(sz<1) {
		printf("nbg header write error.\n");
		fclose(fp2);
		return(1);
	}

	sz=fwrite(device_name,sizeof(device_name),1,fp2);
	if(sz<1) {
		printf("device name write error.\n");
		fclose(fp2);
		return(1);
	}

	sz=fwrite(file_type,sizeof(file_type),1,fp2);
	if(sz<1) {
		printf("file type write error.\n");
		fclose(fp2);
		return(1);
	}

	sz=fwrite(file_offset,sizeof(file_offset),1,fp2);
	if(sz<1) {
		printf("file offset write error.\n");
		fclose(fp2);
		return(1);
	}

	sz=fwrite(file_size,sizeof(file_size),1,fp2);
	if(sz<1) {
		printf("file size write error.\n");
		fclose(fp2);
		return(1);
	}

	sz=fwrite(cid,sizeof(cid),1,fp2);
	if(sz<1) {
		printf("cid write error.\n");
		fclose(fp2);
		return(1);
	}

	sz=fwrite(version,sizeof(version),1,fp2);
	if(sz<1) {
		printf("version write error.\n");
		fclose(fp2);
		return(1);
	}

	sz=fwrite(language,sizeof(language),1,fp2);
	if(sz<1) {
		printf("language write error.\n");
		fclose(fp2);
		return(1);
	}

	for(i=0;i<32;i++) {
		if(i<fm) {
			fp1=fopen(argv[6+(i*2)+1],"rb");
			if(fp1==NULL) {
				printf("NB file open error. (%s)\n",argv[6+(i*2)+1]);
				return(1);
			}
			rr=file_size[i];
			rs=sizeof(fb);
			while(rs>0) {
				if((rr-rs)<0) rs=rr;
				sz=fread(fb,1,rs,fp1);
				if(sz<rs) {
					printf("NB file read error.\n");
					rc=1;
					fclose(fp1);
					break;
				}
				sz=fwrite(fb,1,rs,fp2);
				if(sz<rs) {
					printf("NBG file write error.\n");
					rc=1;
					fclose(fp1);
					break;
				}
				rr=rr-rs;
			}
			fclose(fp1);
		}
	}
	fclose(fp1);
	return(rc);
}
