#include <stdio.h>

int main(int argc,char *argv[]) {
	FILE *fp1,*fp2;
	size_t sz;
	int nbg_header[8];
	char device_name[32];
	int file_type[32];
	int file_offset[32];
	int file_size[32];
	char cid[32];
	char version[16];
	char language[16];
	int fn,rc,sr,rs,rr,i;
	char nh[9],dn[33],ci[33],vr[17],lg[17];
	long fo;
	char fb[65536],nn[32768],wn[32768];

	if(argc<2) {
		printf("usage: nbg2nb <NBG file>\n");
		return(1);
	}

	fp1=fopen(argv[1],"rb");
	if(fp1==NULL) {
		printf("NBG file open error.\n");
		return(1);
	}

	sz=fread(nbg_header,sizeof(nbg_header),1,fp1);
	if(sz<1) {
		printf("nbg header read error.\n");
		fclose(fp1);
		return(1);
	}

	strcpy(nh,"HTCIMAGE");
	for(i=0;i<8;i++) if(nbg_header[i]!=nh[i]) break;
	if(i<8) {
		printf("nbg header error.\n");
		fclose(fp1);
		return(1);
	}

	sz=fread(device_name,sizeof(device_name),1,fp1);
	if(sz<1) {
		printf("device name read error.\n");
		fclose(fp1);
		return(1);

	}

	for(i=0;i<32;i++) dn[i]=device_name[i];
	dn[32]='\0';
	printf("device name : %s\n",dn);

	sz=fread(file_type,sizeof(file_type),1,fp1);
	if(sz<1) {
		printf("file type read error.\n");
		fclose(fp1);
		return(1);

	}

	sz=fread(file_offset,sizeof(file_offset),1,fp1);
	if(sz<1) {
		printf("file offset read error.\n");
		fclose(fp1);
		return(1);

	}

	sz=fread(file_size,sizeof(file_size),1,fp1);
	if(sz<1) {
		printf("file size read error.\n");
		fclose(fp1);
		return(1);

	}

	sz=fread(cid,sizeof(cid),1,fp1);
	if(sz<1) {
		printf("cid read error.\n");
		fclose(fp1);
		return(1);

	}
	for(i=0;i<32;i++) ci[i]=cid[i];
	ci[32]='\0';
	printf("cid         : %s\n",ci);

	sz=fread(version,sizeof(version),1,fp1);
	if(sz<1) {
		printf("version read error.\n");
		fclose(fp1);
		return(1);

	}
	for(i=0;i<16;i++) vr[i]=version[i];
	vr[16]='\0';
	printf("version     : %s\n",vr);

	sz=fread(language,sizeof(language),1,fp1);
	if(sz<1) {
		printf("language read error.\n");
		fclose(fp1);
		return(1);

	}
	for(i=0;i<16;i++) lg[i]=language[i];
	lg[16]='\0';
	printf("language    : %s\n",lg);

	strcpy(nn,argv[1]);
	i=strlen(nn);
	while(i>0 && nn[i]!='.') i--;
	if(nn[i]!='.') i=strlen(nn);
	if(i>32752) {
		printf("NBH file full path is longer.\n");
		fclose(fp1);
		return(1);
	}
	nn[i]='\0';

	rc=0;
	for(i=0;i<32;i++) {
		fo=ftell(fp1);
		if(fo<0) {
			printf("NBG file offset get error.\n");
			rc=1;
			break;
		}
		if(file_size[i]>0) {
			if(file_offset[i]!=fo) {
				printf("file %d : offset warning. (now offset = %X , offset = %X)\n",i,fo,file_offset[i]);
				sr=fseek(fp1,file_offset[i],SEEK_SET);
				if(sr!=0) {
					printf("NBG file seek error.\n");
					rc=1;
					break;
				}
			}
			sprintf(wn,"%s_%02d_%X.nb",nn,i,file_type[i]);
			printf("file %d : type = 0x%X , size = %10d , name = %s\n",i,file_type[i],file_size[i],wn);

			fp2=fopen(wn,"wb");
			if(fp2==NULL) {
				printf("NB file open error.\n");
				return(1);
			}
			rr=file_size[i];
			rs=sizeof(fb);
			while(rs>0) {
				if((rr-rs)<0) rs=rr;
				sz=fread(fb,1,rs,fp1);
				if(sz<rs) {
					printf("NBG file read error.\n");
					rc=1;
					fclose(fp2);
					break;
				}
				sz=fwrite(fb,1,rs,fp2);
				if(sz<rs) {
					printf("NB file write error.\n");
					rc=1;
					fclose(fp2);
					break;
				}
				rr=rr-rs;
			}
			fclose(fp2);
		}
	}
	fclose(fp1);
	return(rc);
}
