#include <stdio.h>
#include <string.h>

int main(int argc,char *argv[]) {
	FILE *fp1,*fp2;
	size_t sz,bs;
	char file_header[7];
	char random_data[16];
	int block_size;
	int signature_size;
	char block_flag;
	char block_data[0x10000];
	char signature_data[0x80];
	int bn,rc,i;
	char nn[32768];

	if(argc<2) {
		printf("usage: nbg2nbh <NBG file>\n");
		return(1);
	}

	fp1=fopen(argv[1],"rb");
	if(fp1==NULL) {
		printf("NBG file open error.\n");
		return(1);
	}

	strcpy(nn,argv[1]);
	i=strlen(nn);
	while(i>0 && nn[i]!='.') i--;
	if(nn[i]!='.') i=strlen(nn);
	if(i>32763) {
		printf("NBG file full path is longer.\n");
		fclose(fp1);
		return(1);
	}
	nn[i]='.';
	nn[i+1]='n';
	nn[i+2]='b';
	nn[i+3]='h';
	nn[i+4]='\0';

	fp2=fopen(nn,"wb");
	if(fp2==NULL) {
		printf("NBH file open error.\n");
		return(1);
	}

	strcpy(file_header,"R000FF");
	file_header[6]='\n';

	sz=fwrite(file_header,1,7,fp2);
	if(sz<1) {
		printf("file header write error.\n");
		fclose(fp2);
		fclose(fp1);
		return(1);
	}

	for(i=0;i<16;i++) random_data[i]=0;

	sz=fwrite(random_data,sizeof(random_data),1,fp2);
	if(sz<1) {
		printf("random data write error.\n");
		fclose(fp2);
		fclose(fp1);
		return(1);
	}

	signature_size=0x80;
	for(i=0;i<signature_size;i++) signature_data[i]=0;
	block_flag=1;
	rc=0;
	bn=0;
	while(1) {
		block_size=fread(block_data,1,sizeof(block_data),fp1);

		sz=fwrite(&block_size,sizeof(block_size),1,fp2);
		if(sz<1) {
			printf("block %d : block size write error.\n",bn);
			rc=1;
			break;
		}

		sz=fwrite(&signature_size,sizeof(signature_size),1,fp2);
		if(sz<1) {
			printf("block %d : signature size write error.\n",bn);
			rc=1;
			break;
		}

		if(block_size==0) block_flag=2;
		sz=fwrite(&block_flag,sizeof(block_flag),1,fp2);
		if(sz<1) {
			printf("block %d : block flag write error.\n",bn);
			rc=1;
			break;
		}

		if(block_size>0) {
			sz=fwrite(block_data,1,block_size,fp2);
			if(sz<block_size) {
				printf("block %d : block data write error.\n",bn);
				rc=1;
				break;
			}
		}

		sz=fwrite(signature_data,1,signature_size,fp2);
		if(sz<signature_size) {
			printf("block %d : signature data write error.\n",bn);
			rc=1;
			break;
		}

		bn++;

		if(block_size==0) {
			printf("%d block finished.\n",bn);
			rc=0;
			break;
		}
	}
	fclose(fp2);
	fclose(fp1);
	return(rc);
}
